; macros.asm
;
; Some useful FASM macros, and constants.

flag_none       = 0
flag_immediate  = 1

mode_interpret  = 0
mode_compile    = 1

macro header code,name,flags {
        local len,str,x,y,z,hash,old_last
str:    db len
        db name
        len = $-str-1
        load x from str
        load y from str+1
        if x = 1
        hash = (x*4 + y*2) and 63
        end if
        if x <> 1
        load z from str+2
        hash = (x*4 + y*2 + z) and 63
        end if
        load old_last word from core+(hash*2)
        dw old_last
        store word str at core+(hash*2)
        dw code
        db flags
}

macro next {
        lodsw                           ; Load address at IP.
        jmp     ax                      ; Jump to the address.
}

; OK, this is ugly. About 20 bytes, that's alot for a function call.
; Must think of some way to get around this, maybe make the functions
; using it high-level?

macro hl_call address {
        local return_address,return_point
        xchg    bp,sp
        push    si
        xchg    bp,sp                   ; Push IP to return stack.
        mov     si,return_address       ; This is where we will return to.
        jmp     address
return_address:
        dw      return_point
return_point:
        xchg    bp,sp
        pop     si
        xchg    bp,sp                   ; Pop IP from return stack.
}
